> For the complete documentation index, see [llms.txt](https://help.security.gallagher.com/knowledge-hub/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://help.security.gallagher.com/knowledge-hub/developer/rest-api/cardholders.md).

# Cardholders

A cardholder is a user account.

These methods give you read and write access to the cardholder data in the Command Centre database. You can download cardholders, create them, search them by name or Personal Data Field (PDF) value, and work on them as you would in the interactive clients.

The first use case below introduces the main entry point. It is a paginated search interface that gives you basic data for any number of cardholders. You will not receive many fields by default, but you can ask for more using the `fields` query parameter.

A field called `href` serves both as a unique identifier for the cardholder and the location of what we call his or her *details* page. You can submit an HTTP GET to that href to retrieve the entire cardholder record, or an HTTP PATCH to update it, or an HTTP DELETE to remove it. Be careful: there is no coming back from deleting a cardholder.

### Efficiency tips

* When searching for a cardholder by personal data or any object by name, if you have the exact string, put it in quotes `"..."`. It is still a case-insensitive search but it attempts to match the entire string. Without the quotes Command Centre will perform a substring search, which is slower and may return more results than you need. In one test, a substring search of half a million cardholders took more than ten seconds, but with quotes it took a tenth of a second. That is a 100x speedup. If the server believes you have omitted the quotes in error, it will include a polite reminder in its results.
* When downloading a significant number of items, sort by ID.
* Set your page size as large as your client can handle. The default was 100 before 8.70; using the `top` parameter to take it to 1000 or more gives *much* better throughput.

To give you an idea of the effect of setting `sort` and `top`, here are some timings for a download of 200,000 cardholders from CC 8.40:

| Sorting           | Pagination    | Time        |
| ----------------- | ------------- | ----------- |
| Default (by name) | Default (100) | 28 minutes  |
| `sort=id`         | Default (100) | 5 minutes   |
| Default (by name) | `top=1000`    | 3.5 minutes |
| `sort=id`         | `top=1000`    | 1 minute    |

* In version 8.00 or later, use the `fields` parameter to add fields to the results of a search, saving you GETting the details page.

  For example, to see the names, personal data fields, and access groups of all your cardholders:

  `GET /api/cardholders?sort=id&top=10000 &fields=firstname,lastname,personalDataFields,accessGroups`

  It adds to the payload size, though, so only do this if you are certain that the search will not return too many cardholders you are not interested in.
* If you are writing an integration that synchronises users from a source of truth to Command Centre, see the 'Synchronising a user directory' use case.
* If you must get an object's details page, and you are on v8.00 or later, using the `fields` parameter will still save work. Be explicit with what you want: do not use `fields=defaults` unless you need every field that 'defaults' gives you and you accept that we may add fields to the defaults in future.
* When creating cardholders, assign their cards, groups, and other attributes in the POST. This is significantly quicker than sending a handful of PATCHes chasing after your POST, and if you are interrupted, you will not end up with a partially-configured cardholder.
* When modifying a cardholder, do all your operations in one PATCH. This is much quicker than doing it in several smaller PATCHes.

### Write-locked cardholders

If an operator has unsaved changes on a cardholder object when your integration attempts to update it, your PATCH will fail with a 409 error. The message will tell you the operator and workstation that is holding the lock; we suggest your application logs that and tries its update again later.

### Licensing

All of the API calls described here are available with the RESTCardholders licence. Licences that enable additional features are described in each route.

### Cardholder use cases

#### Searching for cardholders by name

1. `GET /api`.
2. Follow the link at `features.cardholders.cardholders.href` ↪, appending a search term to narrow the results and the `fields` parameter to add the fields you need.
3. Process the results, following the `next` link until there isn't one.

#### Downloading all cardholders

1. `GET /api`
2. Follow the link at `features.cardholders.cardholders.href` ↪. This is effectively a cardholder search with no filters. You should add `sort` and `top` query parameters to sort by ID and increase the number of cardholders per page: see the efficiency tips!
3. Process the bundle of cardholders in the result.
4. Follow the link at `next.href` if there is one, and repeat.

#### Synchronising a user directory

This is a common use case, described in the section on Cardholder changes. It shows how to:

1. Get a bookmark at the head of the queue of cardholder changes.
2. Do a one-off sync of all cardholders.
3. Loop to stay up to date, starting with the bookmark.

That is how Gallagher's cardholder-synchronising integrations work.

#### Searching for cardholders by Personal Data Field value

Say you want to find a cardholder with a particular employee ID, and Command Centre is holding that in a personal data field called "employee\_ID".

First, reconsider, and look at the 'Synchronising a user directory' use case above. If you are going to be doing this for many cardholders, GETting cardholders in bulk and filtering out the interesting ones client-side is more efficient than a large number of unique PDF searches. You don't have to get all cardholders; you could get all cardholders in one division, or all cardholders with a non-blank value for your PDF (shown below), or a combination. It will be quicker than a sequence of searches that return one cardholder each.

Before you can start a cardholder search, you must find the PDF's identifier.

1. `GET /api`.
2. v8.10 or later: follow the link at `features.personalDataFields.personalDataFields.href` ↪, appending the query `name="employee_id"`. This will return every PDF in the system with that name. There will be more than one, in rare cases.
3. Earlier versions: follow the link at `features.items.items.href` ↪, appending the query `name="employee_id"` (after a `?` or `&`, of course). This will return every item in the system with that name. Pick the one with a type name of 'Personal Data Field'. Or you could append `type=33` to the item search: you will only be shown PDFs.
4. Note the ID of the item. It will be a short alphanumeric.

Case does not matter when searching by name but remember the quotes: Command Centre will perform a substring match if you omit them, which is vastly slower and (for the example above) return you the PDFs 'previous\_employee\_ID' and 'employee\_ID\_allocated\_flag', if you have PDFs with those names.

Now you can use that PDF ID in a cardholder search.

1. Recall the JSON object you received from `GET /api`.
2. Follow the link at `features.cardholders.cardholders.href` ↪, adding a query separator and `pdf_<your_pdf_id>=<your_pdf_value>`, without the angle brackets.

The results will only include cardholders who have *\<your\_pdf\_value>* as a substring of the Personal Data Field with ID *\<your\_pdf\_id>*. Again, the search is case-insensitive and you should bookend *\<your\_pdf\_value>* with quotes if you want to anchor it at each end. In our example we would `GET /api/cardholders?pdf_345="EID8888"`.

Use a percent sign `%` for *\<your\_pdf\_value>* if you want to see all cardholders who have a non-blank value for that PDF.

The server will reply with a default set of fields for your cardholder. If they are not what you'd like, you can use the `fields` query parameter to change them.

See the cardholder GET for more.

#### Creating a cardholder

1. `GET /api`.
2. Use the link at `features.accessGroups.accessGroups.href` to find the hrefs of access groups you wish to add your new cardholder to.
3. Do the same for the competencies, relationships (`roles`), lockers, PDF definitions, and cards/credentials (`cardTypes`) that your new cardholder needs, using other URLs in the `features` section of `/api`. In v8.10, the card types that your operator has the privilege to assign are at a new URL given in the field `features.cardTypes.assign.href` ↪.
4. Compose a JSON body using this example and this detail, then send it in a POST to the href at `features.cardholders.cardholders.href` ↪ on the `/api` page.

#### Modifying a cardholder

1. Find your cardholder using one of the processes above.
2. If you need the current values before you update them, use the `fields` parameter to add fields (such as accessGroups, cards, or competencies) to the search results.
3. PATCH the cardholder's href with a document describing the additions, deletions, and modifications you wish to make to the cardholder and his or her associations.

In its simplest form, your document could be a collection of key/value pairs much the same as you receive from a GET to the same href. More complex forms allow adding, modifying, and removing cards, competencies, group membership, PDFs, and relationships. Three examples follow.

#### Removing a cardholder from groups

1. Find your cardholder using one of the processes above.
2. Follow the link to their details page or add `fields=accessGroups` to the search. That will show all their access group memberships.
3. PATCH the cardholder with the hrefs of the memberships you want to delete in an array called `remove` inside a block called `accessGroups`.

The access groups section describes what to do when you want to start with a group and remove several cardholders from it.

#### Removing all group memberships, competencies, relationships, cards, or lockers

This shows how you could remove a cardholder from all his or her access groups, but you could just as simply apply the process to other fields that come back as arrays, such as competencies, relationships, operator groups, cards, and lockers.

1. GET your cardholder's details page, or search with `accessGroups` in the field list. Either way, you will receive all their access group memberships.
2. Take the array at `accessGroups`, rename it to `remove`, and put it in an object called `accessGroups` at the root level of a JSON object.
3. PATCH the cardholder with that JSON object. That will remove the cardholder from all the groups that came back in the GET.

#### Assigning a new card to a cardholder

1. `GET /api`.
2. Follow the link at `features.cardTypes.cardTypes.href`↪ to find the href for the new card's type.
3. If you want to create a card in a state other than the default, get it from the same page.
4. Find the href for the cardholder using one of the search methods above.
5. Optional: follow the link at `edit.href` on the cardholder page. If there is a link at `update.href` of the results, your REST client has permission to modify the cardholder.
6. PATCH the cardholder's href according to the cardholder patch schema.

#### Deleting a cardholder's PDF value

1. Find the URL of your cardholder using one of the processes above.
2. PATCH your cardholder with this in the body: `{ "@name_of_PDF": null }`

#### Deleting a cardholder

1. Find your cardholder using one of the processes above.
2. Send an HTTP DELETE to the cardholder's href.

#### Updating a cardholder's location

1. Find the href of your target access zone using the link at `features.cardholders.updateLocationAccessZones` ↪ in the results of `GET /api`.
2. Find your cardholder using one of the processes above. If you are using search, add `updateLocation` to the `fields` parameter to save you having to GET their details page later.
3. Send an HTTP POST to that cardholder's `updateLocation.href` link.

#### Finding which access zones and doors a cardholder can access

1. GET your cardholder's details page, or search cardholders with `accessGroups` in the field list. Either way, you will receive all their access group memberships.
2. Iterate through all the access groups looking into their `access` blocks for access zones and schedules. Recurse up the access group hierarchy by following each group's `parent.href`.

Now you have the cardholder's access zones. If you want doors:

3. For each access zone, GET its href and look in its `doors` block.

#### Finding recently-created cardholders

Informing you when Command Centre creates cardholders is a function of the Cardholder changes call, described there.

However for that to work you need to make API calls before and after the cardholders are created. If they already exist, a workaround is to get a page of cardholders sorted by database ID *descending* using `sort=-id&top=10`. Change the ten to the number of cardholders you'd like, obviously. Because Command Centre allocates database IDs to new items in increasing order, the first page you get will be the most-recently created cardholders. This is not suitable for use in a production system! Use the cardholder changes call instead.

### Field names in query parameters

The cardholder search and details operations' `fields` parameter and the change tracking operation's `fields` and `filter` parameters take a list of field names. Other sections of this document describe how those parameters affect the API calls, but their format is the same so this section will cover it once.

You can form the name of a field by joining the components of its JSON path with dots. Fields at the root level of the cardholder object, such as `firstName` and `@emailAddress` (a PDF), have just one component. Fields that are one level down, such as `accessGroups.status`, have two.

Treat the string matches as case sensitive: use `lastName` rather than `lastname`.

The string must not contain any spaces. Just alphanumerics, underscores, commas, and dots.

To serve as examples, this is the list you can choose from in 8.30:

`href`, `id`, `firstName`, `lastName`, `shortName`, `description`, `authorised`, `lastSuccessfulAccessTime`, `lastSuccessfulAccessZone`, `division`, `personalDataFields`, `cards`, `accessGroups`, `competencies`, `notes`, `notifications`, `relationships`, `lockers`, `cards.href`, `cards.number`, `cards.from`, `cards.until`, `cards.cardSerialNumber`, `cards.type`, `cards.status`, `cards.invitation`, `cards.issueLevel`, `cards.pivData`, `cards.pivData.chuid`, `cards.pivData.pivStatus`, `cards.pivData.lastCheckTime`, `cards.pivData.chuid.hash`, `cards.pivData.chuid.fascn`, `cards.pivData.chuid.duns`, `cards.pivData.chuid.orgIdentifier`, `cards.invitation.href`, `cards.invitation.singleFactorOnly`, `cards.invitation.email`, `cards.invitation.mobile`, `notifications.enabled`, `notifications.from`, `notifications.until`, `accessGroups.href`, `accessGroups.accessGroup`, `accessGroups.from`, `accessGroups.until`, `accessGroups.status`, `relationships.href`, `relationships.cardholder`, `relationships.role`, `lockers.href`, `lockers.locker`, `lockers.from`, `lockers.until`

Later versions of Command Centre added many more. See the details operation for the complete list of cardholder fields.

A special value `default` applies a default set of fields that varies with the call you're making.

`personalDataFields` is also special. It will give you the personalDataDefinitions block plus all the PDF values at the root level with their names preceded by '@'-signs.

### Licensing

All of the API calls described here are available with the RESTCardholders licence, with the following exceptions and notes:

* Visitor management calls need both RESTCardholders and VisitorManagement.
* Creating, modifying, and deleting cardholders' connections to competencies requires the RESTCardholders licence.
* Managing access group memberships is enabled by the RESTCardholders licence. Managing access group items, card types, personal data definitions, and roles is coming soon.
* Lockers and locker banks are also available with the RESTStatus licence, and a subset of their fields (enough to allow overriding them) are available with the RESTOverrides licence.

The server will return a 403 if you attempt an operation for which the server is not licensed.

## Search cardholders

> This call returns cardholders matching your search criteria.\
> \
> The result will contain no more than 100 or 1000 cardholders depending on your version; you\
> should follow the \`next\` link, if it is present, to collect the next batch.\
> \
> When you have loaded all the cardholders there will be no \`next\` link.\
> \
> If your result set is empty it means your operator does not have the privilege to view any\
> cardholders.  Perhaps there are none in the divisions in which your operator has privileges,\
> or your operator has no privileges at all.\
> \
> Adding or modifying cardholders between calls to this API will not affect the pagination of\
> its results if you sort by ID.\
> \
> \[Do not code this URL]\(forward-compatibility-hateoas) into your application.  Take it from the \`href\` field in the\
> \`features.cardholders.cardholders\` section of \`/api\`.<br>

```json
{"openapi":"3.2.0","info":{"title":"Command Centre REST API","version":"2.0"},"tags":[{"name":"Cardholders","description":"A cardholder is a user account.\n\nThese methods give you read and write access to the cardholder data in the Command\nCentre database.  You can download cardholders, create them, search them by name or\nPersonal Data Field (PDF) value, and work on them as you would in the interactive\nclients.\n\nThe first use case below introduces the main entry point.  It is a paginated search interface\nthat gives you basic data for any number of cardholders.  You will not receive many fields by\ndefault, but you can ask for more using the `fields` query parameter.\n\nA field called `href` serves both as a unique identifier for the cardholder and the location of\nwhat we call his or her _details_ page.  You can submit an HTTP GET to that href to retrieve the\nentire cardholder record, or an HTTP PATCH to update it, or an HTTP DELETE to remove it.  Be\ncareful:  there is no coming back from deleting a cardholder.\n\n## Efficiency tips\n\n* When searching for a cardholder by personal data or any object by name, if you have the\n  exact string, put it in quotes `\"...\"`.  It is still a case-insensitive search but it attempts\n  to match the entire string.  Without the quotes Command Centre will perform a substring\n  search, which is slower and may return more results than you need.  In one test, a substring\n  search of half a million cardholders took more than ten seconds, but with quotes it took a\n  tenth of a second.  That is a 100x speedup.  If the server believes you have omitted the\n  quotes in error, it will include a polite reminder in its results.\n\n* When downloading a significant number of items, sort by ID.\n\n* Set your page size as large as your client can handle.  The default was 100 before 8.70; using\n  the `top` parameter to take it to 1000 or more gives _much_ better throughput.\n\nTo give you an idea of the effect of setting `sort` and `top`, here are some timings for a\ndownload of 200,000 cardholders from CC 8.40:\n\n| Sorting           | Pagination    | Time\n| ----------------- | ------------- | --------\n| Default (by name) | Default (100) | 28 minutes\n| `sort=id`         | Default (100) | 5 minutes\n| Default (by name) | `top=1000`    | 3.5 minutes\n| `sort=id`         | `top=1000`    | 1 minute\n\n* In version 8.00 or later, use the [`fields` parameter](cardholders#field-names-in-query-parameters) to add fields\n  to the results of a search, saving you GETting the details page.\n\n  For example, to see the names, personal data fields, and access groups of all your cardholders:\n\n    `GET /api/cardholders?sort=id&top=10000 &fields=firstname,lastname,personalDataFields,accessGroups`\n\n  It adds to the payload size, though, so only do this if you are certain that the search will\n  not return too many cardholders you are not interested in.\n\n* If you are writing an integration that synchronises users from a source of truth to Command\n  Centre, see the 'Synchronising a user directory' use case.\n\n* If you must get an object's details page, and you are on v8.00 or later, using the [`fields`\n  parameter](cardholders#field-names-in-query-parameters) will still save work.  Be explicit with what you want:  do\n  not use `fields=defaults` unless you need every field that 'defaults' gives you and you\n  accept that we may add fields to the defaults in future.\n\n* When creating cardholders, assign their cards, groups, and other attributes in the POST.  This is\n  significantly quicker than sending a handful of PATCHes chasing after your POST, and if you\n  are interrupted, you will not end up with a partially-configured cardholder.\n\n* When modifying a cardholder, do all your operations in one PATCH.  This is much quicker than\n  doing it in several smaller PATCHes.\n\n## Write-locked cardholders\n\nIf an operator has unsaved changes on a cardholder object when your integration\nattempts to update it, your PATCH will fail with a 409 error.  The message will tell\nyou the operator and workstation that is holding the lock; we suggest your application\nlogs that and tries its update again later.\n\n## Licensing\n\nAll of the API calls described here are available with the RESTCardholders licence.  Licences\nthat enable additional features are described in each route.\n\n## Cardholder use cases\n\n### Searching for cardholders by name\n1. `GET /api`.\n\n2. Follow the link at `features.cardholders.cardholders.href`\n   [↪](cardholders#get-api-cardholders), appending a search term to narrow the results and\n   the `fields` parameter to add the fields you need.\n\n3. Process the results, following the `next` link until there isn't one.\n\n### Downloading all cardholders \n1. `GET /api`\n\n2. Follow the link at `features.cardholders.cardholders.href`\n   [↪](cardholders#get-api-cardholders).  This is effectively a cardholder search with no\n   filters.  You should add `sort` and `top` query parameters to sort by ID and increase the\n   number of cardholders per page:  see the efficiency tips!\n\n3. Process the bundle of cardholders in the result.\n4. Follow the link at `next.href` if there is one, and repeat.\n\n### Synchronising a user directory\n\nThis is a common use case, described in the section on [Cardholder\nchanges](cardholder-change-tracking).  It shows how to:\n\n1. Get a bookmark at the head of the queue of cardholder changes.\n2. Do a one-off sync of all cardholders.\n3. Loop to stay up to date, starting with the bookmark.\n\nThat is how Gallagher's cardholder-synchronising integrations work.\n\n### Searching for cardholders by Personal Data Field value\n\nSay you want to find a cardholder with a particular employee ID, and Command Centre is\nholding that in a personal data field called \"employee_ID\".\n\nFirst, reconsider, and look at the 'Synchronising a user directory' use case above.  If you are\ngoing to be doing this for many cardholders, GETting cardholders in bulk and filtering out the\ninteresting ones client-side is more efficient than a large number of unique PDF searches.  You\ndon't have to get all cardholders; you could get all cardholders in one division, or all\ncardholders with a non-blank value for your PDF (shown below), or a combination.  It will be\nquicker than a sequence of searches that return one cardholder each.\n\nBefore you can start a cardholder search, you must find the PDF's identifier.\n\n1. `GET /api`.\n\n2. v8.10 or later:  follow the link at `features.personalDataFields.personalDataFields.href`\n   [↪](pdf-definitions#get-api-personal_data_fields), appending the query\n   `name=\"employee_id\"`.  This will return every PDF in the system with that name.  There will\n   be more than one, in rare cases.\n\n2. Earlier versions:  follow the link at `features.items.items.href`\n   [↪](items#get-api-items), appending the query `name=\"employee_id\"` (after a\n   `?` or `&`, of course).  This will return every item in the system with that name.  Pick the\n   one with a type name of 'Personal Data Field'.  Or you could append `type=33` to the item\n   search:  you will only be shown PDFs.\n\n3. Note the ID of the item.  It will be a short alphanumeric.\n\nCase does not matter when searching by name but remember the quotes:  Command Centre will\nperform a substring match if you omit them, which is vastly slower and (for the example above)\nreturn you the PDFs 'previous_employee_ID' and 'employee_ID_allocated_flag', if you have\nPDFs with those names.\n\nNow you can use that PDF ID in a cardholder search.\n\n1. Recall the JSON object you received from `GET /api`.\n2. Follow the link at `features.cardholders.cardholders.href`\n   [↪](cardholders#get-api-cardholders), adding a query separator and\n   `pdf_<your_pdf_id>=<your_pdf_value>`, without the angle brackets.\n\nThe results will only include cardholders who have *\\<your_pdf_value>* as a substring of\nthe Personal Data Field with ID *\\<your_pdf_id>*.  Again, the search is\ncase-insensitive and you should bookend *\\<your_pdf_value>* with quotes if you want to anchor it at\neach end.  In our example we would `GET /api/cardholders?pdf_345=\"EID8888\"`.\n\nUse a percent sign `%` for *\\<your_pdf_value>* if you want to see all cardholders who have a\nnon-blank value for that PDF.\n\nThe server will reply with a default set of fields for your cardholder.  If they are not what\nyou'd like, you can use the `fields` query parameter to change them.\n\nSee the [cardholder GET](cardholders#get-api-cardholders) for more.\n\n### Creating a cardholder\n1. `GET /api`.\n2. Use the link at `features.accessGroups.accessGroups.href` to find the hrefs of access groups\nyou wish to add your new cardholder to.\n\n3. Do the same for the competencies, relationships (`roles`), lockers, PDF definitions, and\ncards/credentials (`cardTypes`) that your new cardholder needs, using other URLs in the\n`features` section of `/api`.  In v8.10, the card types that your operator has the privilege to\nassign are at a new URL given in the field `features.cardTypes.assign.href`\n[↪](cardholders#get-api-card_types-assign).\n\n4. Compose a JSON body using [this example](models#cardholderpost) and [this\ndetail](models#cardholderdetail), then send it in a POST to the href at\n`features.cardholders.cardholders.href` [↪](cardholders#post-api-cardholders) on the\n`/api` page.\n\n### Modifying a cardholder\n1. Find your cardholder using one of the processes above.\n2. If you need the current values before you update them, use the `fields` parameter to add\nfields (such as accessGroups, cards, or competencies) to the search results.\n\n3. [PATCH](cardholders#patch-api-cardholders-id-) the cardholder's href with a\ndocument describing the additions, deletions, and modifications you wish to make to\nthe cardholder and his or her associations.\n\nIn its simplest form, your document could be a collection of key/value pairs much the same as\nyou receive from a GET to the same href.  [More complex forms](models#cardholderpatch)\nallow adding, modifying, and removing cards, competencies, group membership, PDFs, and\nrelationships.  Three examples follow.\n\n### Removing a cardholder from groups\n\n1. Find your cardholder using one of the processes above.\n2. Follow the link to their details page or add `fields=accessGroups` to the search.  That will\n   show all their access group memberships.\n\n3. [PATCH](cardholders#patch-api-cardholders-id-) the cardholder with the hrefs of the\n   memberships you want to delete in an array called `remove` inside a block called\n   `accessGroups`.\n\nThe [access groups](access-groups) section describes what to do when you want to\nstart with a group and remove several cardholders from it.\n\n### Removing all group memberships, competencies, relationships, cards, or lockers\n\nThis shows how you could remove a cardholder from all his or her access groups, but you could\njust as simply apply the process to other fields that come back as arrays, such as competencies,\nrelationships, operator groups, cards, and lockers.\n\n1. GET your cardholder's details page, or search with `accessGroups` in the field list.  Either\n   way, you will receive all their access group memberships.\n\n2. Take the array at `accessGroups`, rename it to `remove`, and put it in an object called\n   `accessGroups` at the root level of a [JSON object](models#cardholderpatch).\n\n3. [PATCH](cardholders#patch-api-cardholders-id-) the cardholder with that JSON object.\n   That will remove the cardholder from all the groups that came back in the GET.\n\n### Assigning a new card to a cardholder\n\n1. `GET /api`.\n\n2. Follow the link at\n`features.cardTypes.cardTypes.href`[↪](cardholders#get-api-card_types) to find the href\nfor the new card's type.\n\n3. If you want to create a card in a state other than the default, get it from the same page.\n\n4. Find the href for the cardholder using one of the search methods above.\n5. Optional:  follow the link at `edit.href` on the cardholder page.  If there is a link at\n   `update.href` of the results, your REST client has permission to modify the cardholder.\n4. PATCH the cardholder's href according to the [cardholder patch\n   schema](models#cardholderpatch).\n\n### Deleting a cardholder's PDF value\n1. Find the URL of your cardholder using one of the processes above.\n4. [PATCH](cardholders#patch-api-cardholders-id-) your cardholder with this in the body:\n  `{ \"@name_of_PDF\": null }`\n\n\n### Deleting a cardholder\n1. Find your cardholder using one of the processes above.\n2. Send an HTTP DELETE to the cardholder's href.\n\n### Updating a cardholder's location\n1. Find the href of your target access zone using the link at\n   `features.cardholders.updateLocationAccessZones`\n   [↪](access-zones#get-api-access_zones-update_cardholder_location) in the results of\n   `GET /api`.\n\n1. Find your cardholder using one of the processes above.  If you are using\n   [search](cardholders#get-api-cardholders), add `updateLocation` to the `fields`\n   parameter to save you having to GET their details page later.\n\n2. Send an [HTTP POST](cardholders#post-api-cardholders-id-update_location) to that\n   cardholder's `updateLocation.href` link.\n\n### Finding which access zones and doors a cardholder can access\n1. GET your cardholder's details page, or search cardholders with `accessGroups` in the field\nlist.  Either way, you will receive all their access group memberships.\n2. Iterate through all the access groups looking into their `access` blocks for access zones and\nschedules.  Recurse up the access group hierarchy by following each group's `parent.href`.\n\nNow you have the cardholder's access zones.  If you want doors:\n\n3. For each access zone, GET its href and look in its `doors` block.\n\n### Finding recently-created cardholders\n\nInforming you when Command Centre creates cardholders is a function of the [Cardholder\nchanges](cardholder-change-tracking) call, described there.\n\nHowever for that to work you need to make API calls before and after the cardholders are\ncreated.  If they already exist, a workaround is to get a page of cardholders sorted by\ndatabase ID _descending_ using `sort=-id&top=10`.  Change the ten to the number of cardholders\nyou'd like, obviously.  Because Command Centre allocates database IDs to new items in\nincreasing order, the first page you get will be the most-recently created cardholders.  This\nis not suitable for use in a production system!  Use the cardholder changes call instead.\n\n## Field names in query parameters\n\nThe cardholder [search](cardholders#get-api-cardholders) and\n[details](cardholders#get-api-cardholders-id-) operations' `fields` parameter and the [change\ntracking](cardholders#get-api-cardholders-changes) operation's `fields` and `filter` parameters\ntake a list of field names.  Other sections of this document describe how those parameters\naffect the API calls, but their format is the same so this section will cover it once.\n\nYou can form the name of a field by joining the components of its JSON path with dots.  Fields\nat the root level of the cardholder object, such as `firstName` and `@emailAddress` (a PDF),\nhave just one component.  Fields that are one level down, such as `accessGroups.status`, have\ntwo.\n\nTreat the string matches as case sensitive:  use `lastName` rather than `lastname`.\n\nThe string must not contain any spaces.  Just alphanumerics, underscores, commas, and dots.\n\nTo serve as examples, this is the list you can choose from in 8.30:\n\n`href`, `id`, `firstName`, `lastName`, `shortName`, `description`, `authorised`,\n`lastSuccessfulAccessTime`, `lastSuccessfulAccessZone`, `division`,\n`personalDataFields`, `cards`, `accessGroups`, `competencies`, `notes`, `notifications`,\n`relationships`, `lockers`,\n`cards.href`, `cards.number`, `cards.from`, `cards.until`, `cards.cardSerialNumber`, `cards.type`,\n`cards.status`, `cards.invitation`, `cards.issueLevel`, `cards.pivData`,\n`cards.pivData.chuid`, `cards.pivData.pivStatus`, `cards.pivData.lastCheckTime`,\n`cards.pivData.chuid.hash`, `cards.pivData.chuid.fascn`, `cards.pivData.chuid.duns`,\n`cards.pivData.chuid.orgIdentifier`,\n`cards.invitation.href`, `cards.invitation.singleFactorOnly`, `cards.invitation.email`,\n`cards.invitation.mobile`,\n`notifications.enabled`, `notifications.from`, `notifications.until`,\n`accessGroups.href`, `accessGroups.accessGroup`, `accessGroups.from`,\n`accessGroups.until`, `accessGroups.status`,\n`relationships.href`, `relationships.cardholder`, `relationships.role`,\n`lockers.href`, `lockers.locker`, `lockers.from`, `lockers.until`\n\nLater versions of Command Centre added many more.  See the\n[details](cardholders#get-api-cardholders-id-) operation for the complete list of\ncardholder fields.\n\nA special value `default` applies a default set of fields that varies with the call you're\nmaking.\n\n`personalDataFields` is also special.  It will give you the personalDataDefinitions block plus\nall the PDF values at the root level with their names preceded by '@'-signs.\n\n## Licensing\n\nAll of the API calls described here are available with the RESTCardholders licence, with the\nfollowing exceptions and notes:\n\n  * Visitor management calls need both RESTCardholders and VisitorManagement.\n\n  * Creating, modifying, and deleting cardholders' connections to competencies requires the\n    RESTCardholders licence.\n\n  * Managing access group memberships is enabled by the RESTCardholders licence.  Managing\n    access group items, card types, personal data definitions, and roles is coming soon.\n\n  * Lockers and locker banks are also available with the RESTStatus licence, and a subset of\n    their fields (enough to allow overriding them) are available with the RESTOverrides licence.\n\nThe server will return a 403 if you attempt an operation for which the server is not licensed.\n"}],"servers":[{"url":"https://127.0.0.1:8904"}],"security":[{"API_key":[]},{"basic":[]}],"components":{"securitySchemes":{"API_key":{"type":"apiKey","name":"Authorization","in":"header","description":"\nClients authenticate by including a pre-shared API key in the `Authorization` header of each\nrequest after an authorisation method of `GGL-API-KEY`:\n\n`Authorization: GGL-API-KEY C774-B01F-D695-AA4B-215F-A158-AC22-ADEB`\n\nFor a fuller description see [API authentication](api-authentication).\n"},"basic":{"type":"http","scheme":"basic","description":"This is HTTP Basic authentication using a blank username and the API key as the password.\n\nExample:  `Authorization: Basic OkM3NzQtQjAxRi1ENjk1LUFBNEItMjE1Ri1BMTU4LUFDMjItQURFQg==`\n\nThat example is equivalent to the example in the description of the api_Key method:\nprepending a colon to the API key beginning with `C774` then encoding it into Base64\nproduces the 56 characters beginning with `OkM3`.\n\nThe colon is a separator between a username, which is blank in our case, and the password,\nwhich is our API key.\n\nFor a fuller description see [API authentication](api-authentication)\n"}},"parameters":{"sort":{"name":"sort","in":"query","schema":{"type":"string","enum":["id","name","-id","-name"]},"required":false,"description":"Changes the sort field between database ID and name.\n\nIf you prefix `id` or `name` with a minus sign (ASCII 45), the sort order is reversed.\n\nThere are two very strong reasons to sort by ID:\n\n1. Sorting by name carries a risk of missing or duplicating objects if your result set spans\n   multiple pages and another operator is editing the database while your REST client is\n   enumerating them.  This is known as \"page drift.\"  Sorting by ID does not carry that risk.\n2. Following a `next` link is _dramatically_ quicker when sorting by ID.\n\nWe _strongly_ recommend sorting by ID.  In case you were still in doubt, we will do that by\ndefault in a future version of Command Centre.\n\nThe server silently ignores anything except the options listed here.\n"},"division":{"name":"division","in":"query","required":false,"schema":{"type":"array","items":{"type":"string"}},"style":"form","explode":false,"description":"Limits the returned items to those that are in these divisions.\n\nThat includes all the items in those divisions' child divisions, because Command Centre treats\nitems as though they are also in their division's parent, and its parent, and so on up to the\nroot division.\n\nSeparate the IDs of the divisions in you are interested with commas.  Item IDs are short\nalphanumeric strings, not URLs.\n\nResults are undefined if you provide an ID that is not in the form of a division ID.\n\nSearch parameters are ANDed together.\n"},"directDivision":{"name":"directDivision","in":"query","required":false,"schema":{"type":"array","items":{"type":"string"}},"style":"form","explode":false,"description":"Restricts items to those whose division is in this list.\n\nUnlike `division=`, it does not follow ancestry.  That means it will limit the search to items\nthat are directly assigned to the divisions you list, whereas `division` (without the\n`direct`) will also include items that are assigned to their descendants.\n\nList the IDs of the divisions you are interested in separated by commas.  Item IDs are short\nalphanumeric strings, not URLs.\n\nBecause this is the first query parameter we added that contains a capital letter, this will\nbe the first time you have had to think about case sensitivity.  `directDivision` works,\n`directdivision` does not.\n\nResults are undefined if you provide an ID that is not in the form of a division ID.\n\nSearch parameters are ANDed together.\n\nAdded in 9.20.\n"},"description":{"name":"description","in":"query","required":false,"schema":{"type":"string"},"description":"Limits the returned items to those with a description that matches this string.  By default it\nis a substring match; surround it with double quotes `\"...\"` for an exact match.  A `_` will\nmatch any single character, and a `%` will match any substring.  With or without quotes,\nhaving either of these wildcards in the string will anchor it at both ends as though you had\nsurrounded it with `\"`.\n\nThe search is always case-insensitive.  Results are undefined if you search for the empty\nstring (`description=` or `description=\"\"`).\n\nSearch parameters are ANDed together.\n"},"pos":{"name":"pos","in":"query","required":false,"schema":{"type":"integer"},"description":"Reserved for internal use.  You may see it in URLs you receive from the server, but you must never add it yourself."},"skip":{"name":"skip","in":"query","required":false,"schema":{"type":"integer"},"description":"Reserved for internal use.  Do not add it to your queries."}},"schemas":{"CardholderSearch":{"title":"Cardholder search","type":"object","properties":{"results":{"type":"array","description":"An array of cardholder summaries.","items":{"$ref":"#/components/schemas/CardholderSummary"}},"next":{"type":"object","properties":{"href":{"type":"string","format":"uri-reference"}},"description":"The link to the next page.  Absent if you have retrieved them all."}},"description":"An array of cardholder summaries, and a `next` link for more."},"CardholderSummary":{"title":"Cardholder summary","type":"object","properties":{"href":{"type":"string","format":"uri-reference","readOnly":true,"description":"A link to a [cardholder detail](models#cardholderdetail) object for this cardholder.\nThis is Command Centre's identifier for this cardholder:  use it whenever you need to\nspecify a cardholder in REST operations.\n"},"id":{"type":"string","description":"An alphanumeric identifier, unique to the server.  No API calls use cardholder IDs.\n\nDeprecated.  Use the href instead.\n","readOnly":true},"firstName":{"type":"string"},"lastName":{"type":"string"},"shortName":{"maxLength":16,"type":"string","description":"If you supply a string that is too long when creating or updating\na cardholder, Command Centre will truncate it.\n"},"description":{"type":"string"},"authorised":{"type":"boolean","description":"This is called 'Cardholder Authorised' in the administrative clients.  If false, Command\nCentre will deny card access decisions for this cardholder.\n\n`authorised` is false by default.  If you want a new cardholder to open doors, be sure to\nset it to true in your POST.\n\nYou need the 'Edit cardholders' privilege to set this true.  In versions prior to 8.80\nyour operator also needed that privilege to set it false, but in 8.80 and later\n'De-authorise cardholder' is enough on its own.\n"}},"description":"The cardholder search at `/api/cardholders` returns an array of these.  It is a subset of what\nyou get from a cardholder's detail page at `/api/cardholders/{id}` (linked as the href in this\nobject), to be more suitable for large result sets.\n"}}},"paths":{"/api/cardholders":{"get":{"tags":["Cardholders"],"summary":"Search cardholders","description":"This call returns cardholders matching your search criteria.\n\nThe result will contain no more than 100 or 1000 cardholders depending on your version; you\nshould follow the `next` link, if it is present, to collect the next batch.\n\nWhen you have loaded all the cardholders there will be no `next` link.\n\nIf your result set is empty it means your operator does not have the privilege to view any\ncardholders.  Perhaps there are none in the divisions in which your operator has privileges,\nor your operator has no privileges at all.\n\nAdding or modifying cardholders between calls to this API will not affect the pagination of\nits results if you sort by ID.\n\n[Do not code this URL](forward-compatibility-hateoas) into your application.  Take it from the `href` field in the\n`features.cardholders.cardholders` section of `/api`.\n","parameters":[{"$ref":"#/components/parameters/sort"},{"name":"top","in":"query","description":"Sets the maximum number of cardholders to return per page.\n\nOlder versions of Command Centre returned 100.  That is acceptable for a GUI application\nthat will only display the first page of cardholders, but for integrations that intend to\nproceed through the entire database it causes a lot of chatter.\n\nVersion 8.70 will return 1000 items per request by default.  1000 is about where a graph\nof performance versus page size begins to level out.  You may see some improvement by\ntaking it even higher.\n","schema":{"minimum":1,"type":"integer"}},{"name":"name","in":"query","description":"Limits the results to cardholders with a name that matches this string.  By default, it is\na substring search against the first name or the last name or the concatenation\n'lastName, firstName'; surround the parameter with double quotes `\"...\"` for an\nexact search.\n\nWithout quotes, a percent sign `%` inside your search string will anchor the search at\nboth ends (so it will no longer be a substring search) and the `%` will match any\nsubstring.  For example, `boothroyd,%` will only match cardholders whose last name is\nBoothroyd.\n\nThe search is always case-insensitive.  Results are undefined if you do a substring search\nfor the empty string (`name=`).  You will receive no cardholders if you search for those\nwith no name (`name=\"\"`), as all items must have a name.\n\nBecause a plus sign `+` represents a space in a query string, replace each plus sign in\nyour search string with `%2B`.\n\nThe search parameters form a logical conjunction.  They are ANDed\ntogether.  Therefore if you search for `name=Mary&pdf_1315=nanny` you will only get back\ncardholders with 'Mary' in their name and 'nanny' in the PDF with ID 1315.\n","schema":{"type":"string"}},{"name":"pdf_{id}","in":"query","description":"Limits the results to cardholders with a value for the Personal Data Field with this ID\nthat matches the parameter.\n\nIt is a substring match by default; surround it with double quotes `\"...\"` for an exact\nmatch.  Tests showed an exact match to be 100x quicker than a substring search on a large\ndatabase.\n\nWithout quotes, `_` will match any single character and `%` will match any substring.\nHaving either in your term will anchor the string at both ends so it will not be a\nsubstring search.  A lone `%` will return any cardholder who has this PDF set to a\nnon-null value.\n\nSearching for a blank value using `pdf_xxx=\"\"` or `pdf_xxx=` currently matches no\ncardholders, which is not useful.  Do not rely on that behaviour since we will change it\nin a future version of Command Centre to return cardholders with no value for that PDF.\n\nBecause a plus sign `+` represents a space in a query string, turn plus signs in your\nstring into `%2B`.\n\nThe search is always case-insensitive.\n\nSearch parameters form a logical conjunction.  They are ANDed\ntogether.  Therefore the search `pdf_1315=nanny&pdf_1315=paratrooper` will only return\ncardholders whose PDF 1315 contains the strings 'nanny' and 'paratrooper'.\n","schema":{"type":"string"}},{"$ref":"#/components/parameters/division"},{"$ref":"#/components/parameters/directDivision"},{"$ref":"#/components/parameters/description"},{"name":"accessZone","in":"query","description":"Limits the results to cardholders who are in one of the access zones with the given IDs.\nDo not put quotes around the IDs, and separate them with commas.\n\nTo get everyone who is in _any_ access zone use `accessZone=*`.  It will return all\ncardholders who have badged at least once and who are not currently 'outside the system'.\nA cardholder is 'outside' if they badge through a door that has no access zone configured for that direction of travel,\nor if an operator manually moves them outside.\n","style":"form","explode":false,"schema":{"type":"array","items":{"type":"string"}}},{"name":"fields","in":"query","description":"Specifies the fields you want in the search results.  The values you can use here are the\nsame as you can for the [details page](cardholders#get-api-cardholders-id-).\nUsing it you can return everything on the search page that you would find on the details\npage with the exception of the `edit` and `updates` links.  Separate values with commas.\n\nUse the value `cards.encodingData` to receive links to the methods that return\ncard-encoding data.\n\nUse the special value `defaults` to return the fields you would have received had you not\ngiven the parameter at all.  Obviously only do that if you have more to add.\n\nUse the special value `personalDataFields` to return the `personalDataDefinitions` block\nas well as the PDF values at the root level of the cardholder object.\n\nUse the special value `pdf_XXX` (where `XXX` is the ID of a PDF definition) to include\njust that PDF.  If you do not have the PDF's ID, and don't mind the performance hit of\nretrieving all the PDFs, using `personalDataDefinitions` may be simpler.\n\nThere is a special value `defaults` which adds everything you would have received had you\nnot sent a `fields` parameter at all, but we advise against its use:  specifying every\nfield you want makes the response more predictable across different server versions.\n\nTreat the string matches as case sensitive:  use 'lastName' rather than 'lastname'.\n\nIn v8.00 you will receive the href and internal ID even if you do not ask for them.  In\n8.10 you will not.  If you are going to send the fields parameter and need the href or ID,\ninclude them.\n","style":"form","explode":false,"schema":{"type":"array","items":{"type":"string"},"default":["defaults"]}},{"$ref":"#/components/parameters/pos"},{"$ref":"#/components/parameters/skip"}],"responses":{"200":{"description":"Success.  See the note in the description about privileges if your result set is empty.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CardholderSearch"}}}},"400":{"description":"The server could not make sense of your search terms."},"403":{"description":"The site does not have the RESTCardholders licence."}}}}}}
```

## Create a cardholder

> This creates a new cardholder, including his or her cards, group memberships, personal data,\
> competencies, and roles.\
> \
> \[Do not code this URL]\(forward-compatibility-hateoas) into your application.  Take\
> it from the \`href\` field in the \`features.cardholders.cardholders\` section of \`/api\`.\
> \
> The POST expects a document in the same format as the \[cardholder\
> detail]\(models#cardholderdetail).  Many fields are optional, of course, and some (like\
> the last successful access time) do not make sense when creating a cardholder.  See the\
> \[cardholder POST example]\(models#cardholderpost) for details.\
> \
> You will achieve better performance if you combine all you want to achieve into one POST,\
> rather than creating the cardholder bare with a POST then adding cards, groups, PDFs, etc.,\
> with PATCHes later.\
> \
> When successful it returns a location header containing the address of the new cardholder.\
> \
> Note that you can only create one cardholder per POST.<br>

```json
{"openapi":"3.2.0","info":{"title":"Command Centre REST API","version":"2.0"},"tags":[{"name":"Cardholders","description":"A cardholder is a user account.\n\nThese methods give you read and write access to the cardholder data in the Command\nCentre database.  You can download cardholders, create them, search them by name or\nPersonal Data Field (PDF) value, and work on them as you would in the interactive\nclients.\n\nThe first use case below introduces the main entry point.  It is a paginated search interface\nthat gives you basic data for any number of cardholders.  You will not receive many fields by\ndefault, but you can ask for more using the `fields` query parameter.\n\nA field called `href` serves both as a unique identifier for the cardholder and the location of\nwhat we call his or her _details_ page.  You can submit an HTTP GET to that href to retrieve the\nentire cardholder record, or an HTTP PATCH to update it, or an HTTP DELETE to remove it.  Be\ncareful:  there is no coming back from deleting a cardholder.\n\n## Efficiency tips\n\n* When searching for a cardholder by personal data or any object by name, if you have the\n  exact string, put it in quotes `\"...\"`.  It is still a case-insensitive search but it attempts\n  to match the entire string.  Without the quotes Command Centre will perform a substring\n  search, which is slower and may return more results than you need.  In one test, a substring\n  search of half a million cardholders took more than ten seconds, but with quotes it took a\n  tenth of a second.  That is a 100x speedup.  If the server believes you have omitted the\n  quotes in error, it will include a polite reminder in its results.\n\n* When downloading a significant number of items, sort by ID.\n\n* Set your page size as large as your client can handle.  The default was 100 before 8.70; using\n  the `top` parameter to take it to 1000 or more gives _much_ better throughput.\n\nTo give you an idea of the effect of setting `sort` and `top`, here are some timings for a\ndownload of 200,000 cardholders from CC 8.40:\n\n| Sorting           | Pagination    | Time\n| ----------------- | ------------- | --------\n| Default (by name) | Default (100) | 28 minutes\n| `sort=id`         | Default (100) | 5 minutes\n| Default (by name) | `top=1000`    | 3.5 minutes\n| `sort=id`         | `top=1000`    | 1 minute\n\n* In version 8.00 or later, use the [`fields` parameter](cardholders#field-names-in-query-parameters) to add fields\n  to the results of a search, saving you GETting the details page.\n\n  For example, to see the names, personal data fields, and access groups of all your cardholders:\n\n    `GET /api/cardholders?sort=id&top=10000 &fields=firstname,lastname,personalDataFields,accessGroups`\n\n  It adds to the payload size, though, so only do this if you are certain that the search will\n  not return too many cardholders you are not interested in.\n\n* If you are writing an integration that synchronises users from a source of truth to Command\n  Centre, see the 'Synchronising a user directory' use case.\n\n* If you must get an object's details page, and you are on v8.00 or later, using the [`fields`\n  parameter](cardholders#field-names-in-query-parameters) will still save work.  Be explicit with what you want:  do\n  not use `fields=defaults` unless you need every field that 'defaults' gives you and you\n  accept that we may add fields to the defaults in future.\n\n* When creating cardholders, assign their cards, groups, and other attributes in the POST.  This is\n  significantly quicker than sending a handful of PATCHes chasing after your POST, and if you\n  are interrupted, you will not end up with a partially-configured cardholder.\n\n* When modifying a cardholder, do all your operations in one PATCH.  This is much quicker than\n  doing it in several smaller PATCHes.\n\n## Write-locked cardholders\n\nIf an operator has unsaved changes on a cardholder object when your integration\nattempts to update it, your PATCH will fail with a 409 error.  The message will tell\nyou the operator and workstation that is holding the lock; we suggest your application\nlogs that and tries its update again later.\n\n## Licensing\n\nAll of the API calls described here are available with the RESTCardholders licence.  Licences\nthat enable additional features are described in each route.\n\n## Cardholder use cases\n\n### Searching for cardholders by name\n1. `GET /api`.\n\n2. Follow the link at `features.cardholders.cardholders.href`\n   [↪](cardholders#get-api-cardholders), appending a search term to narrow the results and\n   the `fields` parameter to add the fields you need.\n\n3. Process the results, following the `next` link until there isn't one.\n\n### Downloading all cardholders \n1. `GET /api`\n\n2. Follow the link at `features.cardholders.cardholders.href`\n   [↪](cardholders#get-api-cardholders).  This is effectively a cardholder search with no\n   filters.  You should add `sort` and `top` query parameters to sort by ID and increase the\n   number of cardholders per page:  see the efficiency tips!\n\n3. Process the bundle of cardholders in the result.\n4. Follow the link at `next.href` if there is one, and repeat.\n\n### Synchronising a user directory\n\nThis is a common use case, described in the section on [Cardholder\nchanges](cardholder-change-tracking).  It shows how to:\n\n1. Get a bookmark at the head of the queue of cardholder changes.\n2. Do a one-off sync of all cardholders.\n3. Loop to stay up to date, starting with the bookmark.\n\nThat is how Gallagher's cardholder-synchronising integrations work.\n\n### Searching for cardholders by Personal Data Field value\n\nSay you want to find a cardholder with a particular employee ID, and Command Centre is\nholding that in a personal data field called \"employee_ID\".\n\nFirst, reconsider, and look at the 'Synchronising a user directory' use case above.  If you are\ngoing to be doing this for many cardholders, GETting cardholders in bulk and filtering out the\ninteresting ones client-side is more efficient than a large number of unique PDF searches.  You\ndon't have to get all cardholders; you could get all cardholders in one division, or all\ncardholders with a non-blank value for your PDF (shown below), or a combination.  It will be\nquicker than a sequence of searches that return one cardholder each.\n\nBefore you can start a cardholder search, you must find the PDF's identifier.\n\n1. `GET /api`.\n\n2. v8.10 or later:  follow the link at `features.personalDataFields.personalDataFields.href`\n   [↪](pdf-definitions#get-api-personal_data_fields), appending the query\n   `name=\"employee_id\"`.  This will return every PDF in the system with that name.  There will\n   be more than one, in rare cases.\n\n2. Earlier versions:  follow the link at `features.items.items.href`\n   [↪](items#get-api-items), appending the query `name=\"employee_id\"` (after a\n   `?` or `&`, of course).  This will return every item in the system with that name.  Pick the\n   one with a type name of 'Personal Data Field'.  Or you could append `type=33` to the item\n   search:  you will only be shown PDFs.\n\n3. Note the ID of the item.  It will be a short alphanumeric.\n\nCase does not matter when searching by name but remember the quotes:  Command Centre will\nperform a substring match if you omit them, which is vastly slower and (for the example above)\nreturn you the PDFs 'previous_employee_ID' and 'employee_ID_allocated_flag', if you have\nPDFs with those names.\n\nNow you can use that PDF ID in a cardholder search.\n\n1. Recall the JSON object you received from `GET /api`.\n2. Follow the link at `features.cardholders.cardholders.href`\n   [↪](cardholders#get-api-cardholders), adding a query separator and\n   `pdf_<your_pdf_id>=<your_pdf_value>`, without the angle brackets.\n\nThe results will only include cardholders who have *\\<your_pdf_value>* as a substring of\nthe Personal Data Field with ID *\\<your_pdf_id>*.  Again, the search is\ncase-insensitive and you should bookend *\\<your_pdf_value>* with quotes if you want to anchor it at\neach end.  In our example we would `GET /api/cardholders?pdf_345=\"EID8888\"`.\n\nUse a percent sign `%` for *\\<your_pdf_value>* if you want to see all cardholders who have a\nnon-blank value for that PDF.\n\nThe server will reply with a default set of fields for your cardholder.  If they are not what\nyou'd like, you can use the `fields` query parameter to change them.\n\nSee the [cardholder GET](cardholders#get-api-cardholders) for more.\n\n### Creating a cardholder\n1. `GET /api`.\n2. Use the link at `features.accessGroups.accessGroups.href` to find the hrefs of access groups\nyou wish to add your new cardholder to.\n\n3. Do the same for the competencies, relationships (`roles`), lockers, PDF definitions, and\ncards/credentials (`cardTypes`) that your new cardholder needs, using other URLs in the\n`features` section of `/api`.  In v8.10, the card types that your operator has the privilege to\nassign are at a new URL given in the field `features.cardTypes.assign.href`\n[↪](cardholders#get-api-card_types-assign).\n\n4. Compose a JSON body using [this example](models#cardholderpost) and [this\ndetail](models#cardholderdetail), then send it in a POST to the href at\n`features.cardholders.cardholders.href` [↪](cardholders#post-api-cardholders) on the\n`/api` page.\n\n### Modifying a cardholder\n1. Find your cardholder using one of the processes above.\n2. If you need the current values before you update them, use the `fields` parameter to add\nfields (such as accessGroups, cards, or competencies) to the search results.\n\n3. [PATCH](cardholders#patch-api-cardholders-id-) the cardholder's href with a\ndocument describing the additions, deletions, and modifications you wish to make to\nthe cardholder and his or her associations.\n\nIn its simplest form, your document could be a collection of key/value pairs much the same as\nyou receive from a GET to the same href.  [More complex forms](models#cardholderpatch)\nallow adding, modifying, and removing cards, competencies, group membership, PDFs, and\nrelationships.  Three examples follow.\n\n### Removing a cardholder from groups\n\n1. Find your cardholder using one of the processes above.\n2. Follow the link to their details page or add `fields=accessGroups` to the search.  That will\n   show all their access group memberships.\n\n3. [PATCH](cardholders#patch-api-cardholders-id-) the cardholder with the hrefs of the\n   memberships you want to delete in an array called `remove` inside a block called\n   `accessGroups`.\n\nThe [access groups](access-groups) section describes what to do when you want to\nstart with a group and remove several cardholders from it.\n\n### Removing all group memberships, competencies, relationships, cards, or lockers\n\nThis shows how you could remove a cardholder from all his or her access groups, but you could\njust as simply apply the process to other fields that come back as arrays, such as competencies,\nrelationships, operator groups, cards, and lockers.\n\n1. GET your cardholder's details page, or search with `accessGroups` in the field list.  Either\n   way, you will receive all their access group memberships.\n\n2. Take the array at `accessGroups`, rename it to `remove`, and put it in an object called\n   `accessGroups` at the root level of a [JSON object](models#cardholderpatch).\n\n3. [PATCH](cardholders#patch-api-cardholders-id-) the cardholder with that JSON object.\n   That will remove the cardholder from all the groups that came back in the GET.\n\n### Assigning a new card to a cardholder\n\n1. `GET /api`.\n\n2. Follow the link at\n`features.cardTypes.cardTypes.href`[↪](cardholders#get-api-card_types) to find the href\nfor the new card's type.\n\n3. If you want to create a card in a state other than the default, get it from the same page.\n\n4. Find the href for the cardholder using one of the search methods above.\n5. Optional:  follow the link at `edit.href` on the cardholder page.  If there is a link at\n   `update.href` of the results, your REST client has permission to modify the cardholder.\n4. PATCH the cardholder's href according to the [cardholder patch\n   schema](models#cardholderpatch).\n\n### Deleting a cardholder's PDF value\n1. Find the URL of your cardholder using one of the processes above.\n4. [PATCH](cardholders#patch-api-cardholders-id-) your cardholder with this in the body:\n  `{ \"@name_of_PDF\": null }`\n\n\n### Deleting a cardholder\n1. Find your cardholder using one of the processes above.\n2. Send an HTTP DELETE to the cardholder's href.\n\n### Updating a cardholder's location\n1. Find the href of your target access zone using the link at\n   `features.cardholders.updateLocationAccessZones`\n   [↪](access-zones#get-api-access_zones-update_cardholder_location) in the results of\n   `GET /api`.\n\n1. Find your cardholder using one of the processes above.  If you are using\n   [search](cardholders#get-api-cardholders), add `updateLocation` to the `fields`\n   parameter to save you having to GET their details page later.\n\n2. Send an [HTTP POST](cardholders#post-api-cardholders-id-update_location) to that\n   cardholder's `updateLocation.href` link.\n\n### Finding which access zones and doors a cardholder can access\n1. GET your cardholder's details page, or search cardholders with `accessGroups` in the field\nlist.  Either way, you will receive all their access group memberships.\n2. Iterate through all the access groups looking into their `access` blocks for access zones and\nschedules.  Recurse up the access group hierarchy by following each group's `parent.href`.\n\nNow you have the cardholder's access zones.  If you want doors:\n\n3. For each access zone, GET its href and look in its `doors` block.\n\n### Finding recently-created cardholders\n\nInforming you when Command Centre creates cardholders is a function of the [Cardholder\nchanges](cardholder-change-tracking) call, described there.\n\nHowever for that to work you need to make API calls before and after the cardholders are\ncreated.  If they already exist, a workaround is to get a page of cardholders sorted by\ndatabase ID _descending_ using `sort=-id&top=10`.  Change the ten to the number of cardholders\nyou'd like, obviously.  Because Command Centre allocates database IDs to new items in\nincreasing order, the first page you get will be the most-recently created cardholders.  This\nis not suitable for use in a production system!  Use the cardholder changes call instead.\n\n## Field names in query parameters\n\nThe cardholder [search](cardholders#get-api-cardholders) and\n[details](cardholders#get-api-cardholders-id-) operations' `fields` parameter and the [change\ntracking](cardholders#get-api-cardholders-changes) operation's `fields` and `filter` parameters\ntake a list of field names.  Other sections of this document describe how those parameters\naffect the API calls, but their format is the same so this section will cover it once.\n\nYou can form the name of a field by joining the components of its JSON path with dots.  Fields\nat the root level of the cardholder object, such as `firstName` and `@emailAddress` (a PDF),\nhave just one component.  Fields that are one level down, such as `accessGroups.status`, have\ntwo.\n\nTreat the string matches as case sensitive:  use `lastName` rather than `lastname`.\n\nThe string must not contain any spaces.  Just alphanumerics, underscores, commas, and dots.\n\nTo serve as examples, this is the list you can choose from in 8.30:\n\n`href`, `id`, `firstName`, `lastName`, `shortName`, `description`, `authorised`,\n`lastSuccessfulAccessTime`, `lastSuccessfulAccessZone`, `division`,\n`personalDataFields`, `cards`, `accessGroups`, `competencies`, `notes`, `notifications`,\n`relationships`, `lockers`,\n`cards.href`, `cards.number`, `cards.from`, `cards.until`, `cards.cardSerialNumber`, `cards.type`,\n`cards.status`, `cards.invitation`, `cards.issueLevel`, `cards.pivData`,\n`cards.pivData.chuid`, `cards.pivData.pivStatus`, `cards.pivData.lastCheckTime`,\n`cards.pivData.chuid.hash`, `cards.pivData.chuid.fascn`, `cards.pivData.chuid.duns`,\n`cards.pivData.chuid.orgIdentifier`,\n`cards.invitation.href`, `cards.invitation.singleFactorOnly`, `cards.invitation.email`,\n`cards.invitation.mobile`,\n`notifications.enabled`, `notifications.from`, `notifications.until`,\n`accessGroups.href`, `accessGroups.accessGroup`, `accessGroups.from`,\n`accessGroups.until`, `accessGroups.status`,\n`relationships.href`, `relationships.cardholder`, `relationships.role`,\n`lockers.href`, `lockers.locker`, `lockers.from`, `lockers.until`\n\nLater versions of Command Centre added many more.  See the\n[details](cardholders#get-api-cardholders-id-) operation for the complete list of\ncardholder fields.\n\nA special value `default` applies a default set of fields that varies with the call you're\nmaking.\n\n`personalDataFields` is also special.  It will give you the personalDataDefinitions block plus\nall the PDF values at the root level with their names preceded by '@'-signs.\n\n## Licensing\n\nAll of the API calls described here are available with the RESTCardholders licence, with the\nfollowing exceptions and notes:\n\n  * Visitor management calls need both RESTCardholders and VisitorManagement.\n\n  * Creating, modifying, and deleting cardholders' connections to competencies requires the\n    RESTCardholders licence.\n\n  * Managing access group memberships is enabled by the RESTCardholders licence.  Managing\n    access group items, card types, personal data definitions, and roles is coming soon.\n\n  * Lockers and locker banks are also available with the RESTStatus licence, and a subset of\n    their fields (enough to allow overriding them) are available with the RESTOverrides licence.\n\nThe server will return a 403 if you attempt an operation for which the server is not licensed.\n"}],"servers":[{"url":"https://127.0.0.1:8904"}],"security":[{"API_key":[]},{"basic":[]}],"components":{"securitySchemes":{"API_key":{"type":"apiKey","name":"Authorization","in":"header","description":"\nClients authenticate by including a pre-shared API key in the `Authorization` header of each\nrequest after an authorisation method of `GGL-API-KEY`:\n\n`Authorization: GGL-API-KEY C774-B01F-D695-AA4B-215F-A158-AC22-ADEB`\n\nFor a fuller description see [API authentication](api-authentication).\n"},"basic":{"type":"http","scheme":"basic","description":"This is HTTP Basic authentication using a blank username and the API key as the password.\n\nExample:  `Authorization: Basic OkM3NzQtQjAxRi1ENjk1LUFBNEItMjE1Ri1BMTU4LUFDMjItQURFQg==`\n\nThat example is equivalent to the example in the description of the api_Key method:\nprepending a colon to the API key beginning with `C774` then encoding it into Base64\nproduces the 56 characters beginning with `OkM3`.\n\nThe colon is a separator between a username, which is blank in our case, and the password,\nwhich is our API key.\n\nFor a fuller description see [API authentication](api-authentication)\n"}},"schemas":{"CardholderPOST":{"title":"Cardholder POST","description":"This is part of the model of a POST body that creates a cardholder.  It does not contain\nevery field you can set when creating a cardholder, but shows the division (which is\nmandatory) and an access group, an access card, a supervisor, a competency, two personal\ndata fields, two lockers, and two elevator groups.\n\nThere are more fields on a cardholder than shown here.  For a complete list please see the\nschema for the detailed [cardholder object](models#cardholderdetail) that you receive\nfrom a cardholder href.\n","required":["division"],"properties":{"firstName":{"type":"string","description":"You must supply either this or the last name when creating a cardholder.\n\nThe maximum length of a cardholder's first name in version 9.50 is 50 characters.\n"},"lastName":{"type":"string","description":"You must supply either this or the first name when creating a cardholder.\n\nThe maximum length of a cardholder's last name in version 9.50 is 50 characters.\n"},"shortName":{"type":"string"},"description":{"type":"string"},"authorised":{"description":"Remember to set this true, as shown here in the POST, or later in a PATCH.  Otherwise your\nnew cardholder will never get through a door.\n","type":"boolean"},"division":{"type":"object","description":"Mandatory when creating any cardholder.  In this example, we want all students\nin division 5387.\n"},"@email":{"description":"An example PDF value.  In this example, access group 352 must include a PDF\ncalled 'email' otherwise this will appear to have no effect.\n","type":"string"},"@headshot":{"description":"An example image PDF encoded to Base64.  Access group 352 must include this PDF as well.\nAs a quick visual check on your encoding, JPEGs start with `/9j/`.\n","type":"string"},"personalDataDefinitions":{"description":"This is how you set and unset the notifications flags on PDFs.  If you do not do it here\nwhen you first give a cardholder a PDF, it will come from the PDF's definition.\n","type":"array","items":{"$ref":"#/components/schemas/CardholderPDF"}},"cards":{"description":"This example creates one physical card of type 600 with a PIN and a system-generated card\nnumber, and\nanother of type 654 which--judging by the invitation block--must be a mobile credential.\nCommand Centre will send an invitation to Nick at those coordinates.\n\nCard PINs were added to the API in 8.90.\n","type":"array","items":{"$ref":"#/components/schemas/CardholderCard"}},"accessGroups":{"type":"array","items":{"$ref":"#/components/schemas/CardholderAccessGroup"},"description":"Here you can add the access groups necessary to give your new cardholder the\nPDFs and access he or she needs.  In this example we set the activation date of\nthe access group membership to the first of January 2019.\n"},"operatorGroups":{"type":"array","items":{"$ref":"#/components/schemas/CardholderOperatorGroup"},"description":"Here you can add the operator groups necessary to give your new cardholder the\nsoftware access he or she needs.  Added in 8.50.\n"},"competencies":{"type":"array","items":{"$ref":"#/components/schemas/CardholderCompetency"},"description":"In this example we are giving our new cardholder a disabled competency, set to enable in\nJanuary 2019.\n"},"notes":{"type":"string"},"notifications":{"type":"object","description":"You can set or update any of the three fields in this block.","properties":{"enabled":{"type":"boolean"},"from":{"type":"string","format":"date-time"},"until":{"type":"string","format":"date-time"}}},"relationships":{"type":"array","items":{"$ref":"#/components/schemas/CardholderRelationship"},"description":"Here you would set the cardholders who will perform roles for this cardholder.\n\nThe example shows that this cardholder will have cardholder 5398 performing role 5396.\n\nRemember that you can supply an array of these objects if your cardholder is having more\nthan one role filled.\n"},"lockers":{"type":"array","description":"Here you set all the cardholder's locker assignments.  Ensure you are only attempting to\ngive your cardholder a locker according to site policy (one locker per locker bank, for\nexample), otherwise the POST will fail.\n\nThe example shows our cardholder receiving two lockers.\n","items":{"$ref":"#/components/schemas/CardholderLocker"}},"elevatorGroups":{"type":"array","description":"Here you set all the new cardholder's default elevator floors and passenger types. Passenger type properties\nare false by default.\n\nThe example shows our cardholder receiving a default floor for the first elevator group,\nwith the Code Blue feature enabled in the second group.\n\nAdded in 8.50.\n","items":{"$ref":"#/components/schemas/CardholderElevatorGroup"}}}},"CardholderPDF":{"title":"Cardholder PDF","description":"A personal data definition and its value for a cardholder.  Each definition is an object\ncontaining one property named after the PDF (plus a leading '@'), which in turn contains its\nvalue and notifications flag for the containing cardholder and an object containing some of\nthe PDF definition's basic fields.\n\nThis is returned as part of a [cardholder](models#cardholderdetail), and you can send it\nin a [POST](models#cardholderpost) or a\n[PATCH](models#cardholderpatch) to set the PDF's value and notification flag for\na cardholder.  The server will ignore the `definition` block if you send it back.  It uses the\nname of the block (minus its leading `@`) to find the PDF to change.\n\nWhile you can use this structure to change the value of a cardholder's PDF, it may be simpler\nto put a property in the root of the payload named after the PDF with a leading '@'.\n","type":"object","additionalProperties":{"$ref":"#/components/schemas/CardholderPDFContent"}},"CardholderPDFContent":{"title":"Cardholder PDF content","type":"object","properties":{"href":{"type":"string","description":"GET this link to receive this cardholder's value for this PDF.  If it is an image you will\nreceive the raw image data with an appropriate content-type.  A browser will render it\ncorrectly.\n\nIf the PDF is not an image the content type will be text/plain, encoded (like\neverything else in this API) as UTF-8.  But you should only use it for image PDFs\nbecause:\n\n* Values for scalar PDF types (everything except images) are also given to you in the\n  `value` field in this object, described below.\n\n* The format of date PDFs varies with the Command Centre version.  Old servers return\n  it in a format that depends on the server's locale.  This was a bug.  Newer servers\n  use ISO 8601.\n\n* If you learn this URL while a cardholder has the PDF, then the cardholder loses\n  it, then you GET the URL, results will vary depending on the server version.  The\n  correct result is a 404, and if the PDF is an image or the server is recent you\n  will see that.  But old servers may return a blank string or even a 500 for\n  non-image PDFs.\n\nThis field will be absent if the cardholder does not have a value for the PDF.\n\nIt is read-only:  do not send it in a PATCH or POST.\n","format":"uri-reference","readOnly":true},"definition":{"type":"object","properties":{"href":{"type":"string","description":"This is the href of the PDF's definition, common to all cardholders who hold a value\nfor this PDF.\n","format":"uri-reference"},"name":{"type":"string","description":"The PDF's name, without an '@' prefix.\n"},"id":{"type":"string","description":"Short alphanumeric identifier used elsewhere in the API to filter cardholder searches\nand add PDF values to alarm and event GETs.\n"},"type":{"type":"string","enum":["string","image","strEnum","numeric","date","address","phone","email","mobile"]}},"description":"The definition object is read-only:  do not send it in a PATCH or POST.\n","readOnly":true},"value":{"description":"In a GET response for text, numeric, and date PDFs this will be a scalar containing the\nvalue, but for image PDFs it will be an object containing a copy of the `href` field\nabove.  For date PDFs the string will comply with RFC 3339, but may or may not contain a\ntime depending on the version of Command Centre.  Newer versions omit the `T` separator\nand everything after it.  If there, it will be midnight UTC.\n\nIn versions up to and including 8.60, if a cardholder did not have an image PDF captured\n(in other words they were a member of an access group that included an image PDF, but they\ndid not have a value for it) the API returned the string 'Not captured' in the `value`\nfield.  Versions 8.70 and later will not return the `value` field at all if there is no image.\n\nIn a POST or PATCH send text PDFs (including dates) as strings, numeric PDFs as numbers or\nstrings that parse to numbers, and image data Base64-encoded into a string.\n","oneOf":[{"type":"integer","title":"Numeric","description":"The scalar value of the numeric PDF."},{"type":"string","title":"Text or date","description":"The scalar value of the text or date PDF."},{"type":"object","title":"Image","description":"An object containing an href which, when requested from the server, returns the\nimage PDF.  The server does not transcode images:  it will arrive as the same\ncontent type as uploaded.\n","properties":{"href":{"type":"string","format":"uri-reference","readOnly":true,"description":"Only present for image PDFs, this will be a copy of the href field in the parent\nobject.  When requested from the server it will return the image PDF as it was\nuploaded.\n"}}}]},"notifications":{"type":"boolean","description":"In a GET response, this will only appear for email and mobile PDF types.  In a POST or\nPATCH, it only makes sense for the same types.\n\nIf true, cardholder notifications will go to the telephone number or email address held by\nthis PDF.  Cardholders can have their notifications go to as many contacts as they wish.\n"}}},"CardholderCard":{"title":"Cardholder card","type":"object","properties":{"href":{"type":"string","readOnly":true,"description":"DELETE this link to delete a card.\n\nDo not specify it when creating a card.\n\nDELETE is the only verb you can use on this URL.  GET will always return a 404 in the\ncurrent versions of Command Centre.\n","format":"uri-reference"},"number":{"type":"string","description":"For a physical access card, this is its card number.  It must be unique across all cards\nof the same card type.  If you leave it blank when creating a card of a type that has a\ndecimal number format, Command Centre will use the next available number.\n\nCard numbers for a mobile credential need not be unique.  They are strings, and are not\nused by Command Centre except for display.\n\nCard numbers for digital IDs are GUIDs.\n\nThis field is mandatory for card types with text or PIV number formats.  If the card type\nhas a text card number format with a regular expression and you supply a card number that\ndoes not match that regex, Command Centre will reject your update.\n\nPIV card numbers must be the same as the card's FASC-N.  PIV-I card numbers must not.\n\nThis field is also mandatory for PIV, PIV-I, tracking tag, GovPass, and Universal Credential\n(`profileCredential`) classes.\n\nOne rule is common across all card types:  you cannot change the number of an existing\ncard or credential.\n"},"cardSerialNumber":{"type":"string","description":"The serial number (CSN, MIFARE UID) of a physical access card as a hex string without a\nleading '0x'.  The number is encoded in the traditional way, with an even number of\nnumbers and the letters from 'A' through 'F', but the '0x' is missing when it comes out\nof the API and it must be missing when you send it back.\n\nThe example shows a seven-byte serial in the order you can expect in a\nGET and should use in a PATCH or POST.  Those on NXP MIFARE cards start with 04 and end\nwith 80 or 90.\n\nFour-byte serial numbers are in the same format, but shorter: `\"EBD62D25\"`, for example.\n\nThis may not be present on very old cards.\n\nThis field was read-only until 7.90.  It is read-write in 8.00 and later.\n"},"issueLevel":{"maximum":15,"minimum":0,"type":"integer","description":"The issue level of a physical access card.  If two cards have the same number\nbut different issue levels, only the one with this issue level will gain access.\n\nIf you leave it blank when creating a card, Command Centre will pick an appropriate value.\n\nIf you increase it when modifying a card, all cards with lower issue levels will stop working.\n\nThe only credential classes for which an issue level is relevant are `card`, PIV, and\nPIV-I.  Some other credential classes currently accept and ignore issue levels, but may\nreject them in a future version.\n"},"status":{"type":"object","properties":{"value":{"type":"string","description":"This card's state, taken from the card type's state set.  The default card\nstate set contains 'Active', 'Disabled (manually)', 'Lost', 'Stolen', and\n'Damaged', or translations of those into the server's language.  Your card state sets may\ndiffer, as they are customisable. [PIV cards](piv) have extra values.\n\nIn addition to the values in the card type's state set, it will be 'Not Yet Activated'\nif the card's activation date is in the future, 'Expired' if its deactivation date has\npassed, or 'Disabled (by inactivity)' if that is the site's policy and the card has\nnot been used at a door.\n\nBecause the value of the `value` field is set by site administrators, you\nshould not use it for programmatically determining whether a card is active.\nUse `type` instead.  Use `value` for display.\n\nWhen creating or updating a card, set `value` to one of the valid card states from the\ncard state set.  Command Centre is not fussy about case.  If you omit it when you\ncreate a card, Command Centre will use the default for the card state set (which is\n'active' for the factory state set).\n\nIf you omit both this and the PIV status when creating or updating a PIV card, or omit\nthis and set the PIV status to 'normal' or 'offline', the server will set this to\n'active'.  Any other PIV status will cause the card to become inactive, regardless of\nwhat you put here.  So you really only need to set this when you are changing the PIV\nstatus to 'normal' or 'offline' but you want to disable the card.  In that case, set\n`status.value` to 'disabled (manually)'.\n"},"type":{"type":"string","description":"This will be 'pending' if the activation date (`from`) is in the future,\n'expired' if its deactivation date (`until`) is in the past, or 'inactive'\nif it is disabled for one of the reasons given in the card state.\n\nNever send `type`:  Command Centre always infers it.\n","readOnly":true,"enum":["pending","active","expired","inactive"]}},"description":"Each card has two status codes:  `value`, and `type`, covered in separate sections below.\n\n`value` is human-readable.  It comes from the _Card State Set_ configured by the site, and\ncould be adjusted according to the card's activation dates.  The REST API and this\ndocument do not cover card state sets because in most cases, the default set is\nsufficient.  See the online help for the Command Centre client if you wish to create your\nown.\n\nThe second field, `type`, comes from a fixed enumeration, and so is better suited than\n`value` for integrations.  Command Centre derives it from the card's state and activation\ndates.\n"},"type":{"type":"object","properties":{"href":{"type":"string","format":"uri-reference"},"name":{"type":"string"}},"description":"The name of the card type from the site configuration, and a link to the card type object.\n\nWhen creating a card, the href must be a card type that makes sense for the other values\nyou placed in this object.\n\nYou cannot change a card's type once it is created.\n"},"invitation":{"type":"object","properties":{"email":{"type":"string","description":"The email address to which Command Centre will send or did send an invitation for this\ncredential.\n"},"mobile":{"type":"string","description":"The telephone number to which Command Centre will send or did send an SMS containing a\nconfirmation code for this invitation.\n"},"singleFactorOnly":{"type":"boolean","description":"If you set this true Command Centre will not require a PIN or fingerprint from the\ncardholder when they enrol.  Be aware that without that second authentication factor,\nzones in modes that require a PIN and readers that always require a second factor will\nnot grant access to the cardholder.\n\n`singleFactorOnly` will only be in the result of a GET if it is true.  If it is false,\nthe field will be missing.\n","default":false},"status":{"type":"string","description":"\n- `sent` means Command Centre is waiting for the user to accept the invitation, either\n  in Gallagher Mobile Connect or another app that uses the Mobile Connect SDK.\n\n- `accepted` means that the credential is ready for use.\n\n- `notSent` means the credential is only a few seconds old or Command Centre is having\n  trouble contacting the cloud.\n\n- `expired` means that Command Centre did not receive a response in time.\n","readOnly":true,"enum":["notSent","sent","expired","accepted"]},"href":{"type":"string","description":"Mobile applications use this URL to accept this invitation.  See the Mobile Connect\nSDK documentation for how to do that in your own applications.\n\nOnly present if `status` is 'sent'.\n","format":"uri-reference","readOnly":true}},"description":"Command Centre will only return this object for a mobile credential, and you should send\nit only when creating one.  In the interests of security you cannot modify the invitation\nblock of an existing credential.  Someone's thumb might be on its way to accept it, after all.\nIf there was something wrong with it you should delete it and start afresh.\n\nWhether you should send `mobile` or `email` when creating a mobile credential depends on\nwhether you are using the Gallagher mobile apps or your own.\n\nIf you specify either `mobile` or `email` to early-version servers you must also supply the\nother so that Command Centre can send both an email invitation and a confirmation SMS.  It\nis an error to only specify one on those servers.\n\nLater versions of Command Centre made the SMS verification optional to better support\ninstallations that use the Gallagher apps but prefer not to depend on cellular connectivity.\nYou do not need to send a mobile number when creating such a credential.\n\nIf you do not give an email address Command Centre cannot send an invitation to the\ncardholder.  It will be up to another application to complete the creation of this\ncredential using the Mobile Connect SDK.\n\nYou should not send a mobile number when creating a credential for use by third-party apps\nthat use the Mobile Connect SDK.  SMS is not supported there.\n\nFor more detail on using the Mobile Connect SDK, including more complete coverage of how\nan email address and mobile number are used in the provisioning process, see its\ndocumentation at [gallaghersecurity.github.io](https://gallaghersecurity.github.io).\n"},"from":{"type":"string","description":"The start of the time period during which this card is active.  If this time is in the\nfuture, the card is not active.\n\nWhen it is not set, Command Centre acts as though it is set to a time in the distant past.\n\nWhen creating a card, leave this property out (or send `null`) to use the card type's\ndefault start time, if the card type has one.  Send an empty string `\"\"` to create the card\nwith no start time even when the card type has a default.  `from` and `until` are treated\nindependently, so leaving out `from` while sending `until` still applies the card type's\ndefault `from`.\n\nWhen modifying a card, send an empty string `\"\"` to reset it.\n\nAny value you send other than a blank string or null must be in RFC 3339 format,\nincluding a timezone.  It must be before midnight on the morning of January 1, 2100 in\nthe server's _local_ time (so servers with positive timezone offsets have maximums\nduring December 31 2099), and it must be less than or equal to the `until` time.  A\nfuture version of Command Centre will clamp too-high values to December 31 2099 and\nreturn a 2xx (success) instead of 400 in that case.\n\nThe server rejects a timestamp that is not in an acceptable format with a 400, whether the\ncard is being created or modified.\n","format":"date-time"},"until":{"type":"string","description":"The end of the time period during which this card is active.  If this time is in the past,\nthe card is not active.\n\nWhen it is not set, Command Centre acts as though it is set to a time in the distant future.\n\nWhen creating a card, leave this property out (or send `null`) to use the card type's\ndefault expiry, if the card type has one: either its fixed end time, or its duration\ncounted from the time the card is created.  Send an empty string `\"\"` to create the card\nwith no end time even when the card type has a default.  `from` and `until` are treated\nindependently, so leaving out `until` while sending `from` still applies the card type's\ndefault `until`.\n\nWhen modifying a card, send an empty string `\"\"` to reset it.\n\nAny value you send other than a blank string or null must be in RFC 3339 format,\nincluding a timezone.  It must be before midnight on the morning of January 1, 2100 in\nthe server's _local_ time (so servers with positive timezone offsets have maximums\nduring December 31 2099), and it must be greater than or equal to the `from` time.  A\nfuture version of Command Centre will clamp too-high values to December 31 2099 and\nreturn a 2xx (success) instead of 400 in that case.\n\nThe server rejects a timestamp that is not in an acceptable format with a 400, whether the\ncard is being created or modified.\n","format":"date-time"},"credentialClass":{"type":"string","description":"This indicates the type of the card.  It comes from an enumeration, and is a reliable way\nof determining the credential's type.\n\nAdded in 8.00.\n\nThe experimental `applePass` was added in 9.10.  Its name may change in future versions.\n\nThe `govPass` credential class will change its name in 9.30.\n","readOnly":true,"enum":["card","digitalId","govPass","mobile","piv","pivi","profileCredential","trackingTag","transact"]},"trace":{"type":"boolean","description":"If set, using this credential will generate an event.\n\nThis field is not in the default set so you will not see it unless you ask for it using\nthe `fields` query parameter.\n\nAdded in 8.30.\n"},"lastPrintedOrEncodedTime":{"type":"string","description":"The date and time this card was last printed or encoded.  It will not come out by\ndefault - you need to ask for it with `fields=cards.lastPrintedOrEncodedTime`.\n\nAdded in 8.40.\n","format":"date-time","readOnly":true},"lastPrintedOrEncodedIssueLevel":{"maximum":15,"minimum":1,"type":"integer","description":"The issue level of this card when it was last printed or encoded, provided it was\nnon-zero.  It will not come out by default - you need to ask for it with\n`fields=cards.lastPrintedOrEncodedIssueLevel`.\n\nAdded in 8.40.\n","readOnly":true},"lastUsedTime":{"description":"When a Gallagher controller last observed the credential in use.\n","type":"string","format":"date-time","readOnly":true},"pin":{"type":"string","description":"This is a write-only field.\nYou can use it in POSTs and PATCHes but the server will not send it to you.\n\nBeing numeric, you might be tempted to send PINs to the server without surrounding\nquotes.  However if you do that, leading zeros will be lost and the resulting behaviour\nis undefined.\n\n8.90 servers will reject your request if the card's `credentialClass` is not `card`,\n`piv`, `pivi`, or `govPass`.  More recent servers will issue a warning in that case, and\nwill not set the PIN, but will allow the rest of the update.\n\nPINs were added to the API in 8.90.\n"},"visitorContractor":{"type":"boolean","description":"This is a credential property only for GovPass, indicating that the enrolled credential is\nfor a visitor / contractor.\n\nIt is a write-once field new to 9.00.\n"},"ownedBySite":{"type":"boolean","description":"This is a credential property only for GovPass, indicating if the site is the owner of the\ncard.\n\nIt is a read-only field new to 9.00.\n","readOnly":true},"credentialId":{"type":"string","description":"Reserved for use by Gallagher applications."},"bleFacilityId":{"type":"string","description":"Reserved for use by Gallagher applications."},"encodingData":{"type":"object","readOnly":true,"properties":{"mifareClassic":{"type":"object","properties":{"href":{"type":"string","format":"uri-reference"}}},"mifareDesfire":{"type":"object","properties":{"href":{"type":"string","format":"uri-reference"}}}},"description":"This block contains links to the calls that return the data you will need to encode\nMIFARE DESFire and Classic cards.  For more on that see the 'Card Encoding' tag.\n\nRead-only:  the server will ignore it if you send it.\n\nAdded in 9.50.\n\nNot returned by default:  ask for it by adding `cards.encodingData` to your `fields`\nquery parameter.\n"},"deviceType":{"type":"string","enum":["applePhone","appleWatch","androidPhone","androidWatch"],"description":"Required when creating a wallet credential.  Either `applePhone` or `appleWatch` when\ncreating an Apple credential, and either `androidPhone` or `androidWatch` for Google.\n\nWallet credentials are part of the Universal Credentials feature added in 9.60.\n"}},"description":"A _card_ is an access credential, including physical cards and mobile (Bluetooth and NFC)\ncredentials and digital IDs.  The server returns it as part of a [cardholder's\ndetails](models#cardholderdetail), and you supply it when creating or modifying a card\nor credential on a cardholder.\n\nEvery card has a type, a status, and a validity period.  Its type determines other fields of\nrelevance, described below.\n\nPIV cards are complex enough to warrant a [tag of their own](piv).\n"},"CardholderAccessGroup":{"title":"Cardholder access group membership","type":"object","properties":{"href":{"type":"string","description":"This is the href of the cardholder's membership to an access group, not an access group\nitem.\n\nDELETE it to remove this group membership, and use it in the body of a PATCH to a\ncardholder to identify memberships you want to modify.\n\nNote that changing an access group membership with a PATCH will change this href, so do\nnot cache it.\n\nDELETE is the only verb you can use on this URL.  GET returns a 404.\n","format":"uri-reference"},"accessGroup":{"type":"object","description":"An object containing the group's href (which is also a link to its detail page) and,\nwhen sent by the server, the group's name.  You should not send this object when\nmodifying a group membership because you cannot change a group membership's group; you\ncan only change its dates.  But you must send it when adding a new group membership, of\ncourse, because it identifies the cardholder's new group.  Just send the group's href:\ndon't bother with the name.\n\n8.70 and later will not return the link if your operator does not have the privilege to\nview the access group (given by 'View access groups', for example).\n","properties":{"name":{"type":"string","readOnly":true},"href":{"type":"string","format":"uri-reference","description":"The API's identifier for an item."}}},"status":{"type":"object","properties":{"value":{"type":"string","description":"The state of this cardholder's access group membership, in the site's language.  In an\nEnglish locale the value is the same as the type, but capitalised.\n","readOnly":true},"type":{"type":"string","description":"The state of this cardholder's access group membership.\n\nThis will be 'pending' if the activation date is set and in the future,\n'expired' if its deactivation date is set and in the past, or 'active'.\n","readOnly":true,"enum":["pending","expired","active"]}},"description":"The two fields in this block are read-only because they are determined by the `from` and\n`until` dates.\n","readOnly":true},"from":{"type":"string","description":"The start of the time period during which this group membership is active.  If this time\nis in the future, the membership will be inactive.  If null or in the past and `until`\nis null or in the future, the membership will be active.\n\nWhen sending this to a server of version 7.90.883 or earlier, use UTC with a trailing 'Z'.\nMore recent versions understand timezone offsets.\n","format":"date-time"},"until":{"type":"string","description":"The end of the time period during which this group membership is active.  If this time\nis in the past, the membership will be inactive.  If null or in the future and `from` is\nnull or in the past, the membership will be active.\n\nWhen sending this to a server of version 7.90.883 or earlier, use UTC with a trailing 'Z'.\nMore recent versions understand timezone offsets.\n","format":"date-time"}},"description":"An _access group_ is an object in Command Centre.  This section is about a connection between an access group and\na cardholder, called a _membership_.  A cardholder can be a member of many groups, and groups\ncan have any number of members.\n\nLess obvious is that a cardholder can have many memberships to the same group.  This is useful\nbecause a membership has a validity period, expressed with `from` and `until` date-times.\nOutside those moments Command Centre does not regard the cardholder as being a member of the\ngroup.  If there exists one membership with `from` in the past or unset and `until` in the\nfuture or unset, the cardholder is a member.\n\nPresence in an access group affects physical access rights and possession of PDFs, among other\nthings.\n\nThe membership object will come from the server in a cardholder's details if you ask for it, and you send it to\nthe server when modifying a cardholder's group memberships.  All uses are described below.\n"},"CardholderOperatorGroup":{"title":"Cardholder operator group membership","description":"An _operator group_ is an object in Command Centre.  The connec
[...]
